﻿using HEAL.Attic;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.PermutationEncoding;
using HeuristicLab.EvolutionTracking;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.TravelingSalesman.Analyzers {
  [Item("TSPGenealogyAnalyzer", "A genealogy analyzer for permutation encodings.")]
  [StorableType("FA2F2F6D-886A-41B4-AF1F-F9F6DA42601B")]
  public class TSPGenealogyAnalyzer : GenealogyAnalyzer<Permutation> {
    public TSPGenealogyAnalyzer() { }

    [StorableConstructor]
    protected TSPGenealogyAnalyzer(StorableConstructorFlag _) : base(_) { }

    public TSPGenealogyAnalyzer(TSPGenealogyAnalyzer original, Cloner cloner) : base(original, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new TSPGenealogyAnalyzer(this, cloner);
    }

    protected override void EvaluateIntermediateChildren() {
      throw new System.NotImplementedException();
    }
  }
}
